"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NestjsEventStoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const nestjs_event_store_constant_1 = require("./contract/nestjs-event-store.constant");
const event_store_1 = require("./event-store");
const nestjs_event_store_provider_1 = require("./providers/nestjs-event-store.provider");
const explorer_service_1 = require("@nestjs/cqrs/dist/services/explorer.service");
const cqrs_1 = require("@nestjs/cqrs");
let NestjsEventStoreModule = NestjsEventStoreModule_1 = class NestjsEventStoreModule {
    static forRoot(option) {
        const configProv = {
            provide: nestjs_event_store_constant_1.ProvidersConstants.EVENT_STORE_CONNECTION_CONFIG_PROVIDER,
            useValue: Object.assign({}, option),
        };
        return {
            module: NestjsEventStoreModule_1,
            providers: [configProv],
            exports: [configProv],
        };
    }
    static forFeature(config) {
        if (config === undefined || config === null) {
            throw new Error('Config missing');
        }
        return {
            module: NestjsEventStoreModule_1,
            providers: [
                explorer_service_1.ExplorerService,
                {
                    provide: nestjs_event_store_constant_1.ProvidersConstants.EVENT_STORE_STREAM_CONFIG_PROVIDER,
                    useValue: Object.assign({}, config),
                },
                event_store_1.EventStore,
            ],
            exports: [
                event_store_1.EventStore,
                explorer_service_1.ExplorerService,
            ],
        };
    }
};
NestjsEventStoreModule = NestjsEventStoreModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({
        imports: [cqrs_1.CqrsModule],
        providers: [
            ...nestjs_event_store_provider_1.eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
        exports: [
            ...nestjs_event_store_provider_1.eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
    })
], NestjsEventStoreModule);
exports.NestjsEventStoreModule = NestjsEventStoreModule;
//# sourceMappingURL=nestjs-event-store.module.js.map