var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NestjsEventStoreModule_1;
import { Global, Module } from '@nestjs/common';
import { ProvidersConstants } from './contract/nestjs-event-store.constant';
import { EventStore } from './event-store';
import { eventStoreProviders } from './providers/nestjs-event-store.provider';
import { ExplorerService } from '@nestjs/cqrs/dist/services/explorer.service';
import { CqrsModule } from '@nestjs/cqrs';
let NestjsEventStoreModule = NestjsEventStoreModule_1 = class NestjsEventStoreModule {
    static forRoot(option) {
        const configProv = {
            provide: ProvidersConstants.EVENT_STORE_CONNECTION_CONFIG_PROVIDER,
            useValue: {
                ...option,
            },
        };
        return {
            module: NestjsEventStoreModule_1,
            providers: [configProv],
            exports: [configProv],
        };
    }
    static forFeature(config) {
        if (config === undefined || config === null) {
            throw new Error('Config missing');
        }
        return {
            module: NestjsEventStoreModule_1,
            providers: [
                ExplorerService,
                {
                    provide: ProvidersConstants.EVENT_STORE_STREAM_CONFIG_PROVIDER,
                    useValue: {
                        ...config,
                    },
                },
                EventStore,
            ],
            exports: [
                EventStore,
                ExplorerService,
            ],
        };
    }
};
NestjsEventStoreModule = NestjsEventStoreModule_1 = __decorate([
    Global(),
    Module({
        imports: [CqrsModule],
        providers: [
            ...eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
        exports: [
            ...eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
    })
], NestjsEventStoreModule);
export { NestjsEventStoreModule };
//# sourceMappingURL=nestjs-event-store.module.js.map